#include <math.h>
#include "glass.h"

Glass::Glass(int w, int h) {
	width = w;
	height = h;
}

Glass::~Glass(void) {
}

void Glass::init(void) {
}

void Glass::draw(unsigned int *buffer, int time, unsigned int *image, unsigned int *map) {
	int r,g,b;
	int pixel, diff;
	int mapWidth = width+1;
	for (int y = 0; y < height; y++) {
		for (int x = 0; x < width; x++) {
			pixel = *image++;
			diff = map[y*mapWidth+x]-map[y*mapWidth+x+1]+map[y*mapWidth+x]-map[(y+1)*mapWidth+x];
			r = (pixel&0x00FF0000)>>16;
			g = (pixel&0x0000FF00)>>8;
			b = pixel&0x000000FF;
			r += diff;
			g += diff;
			b += diff;
			if (r<0) r = 0;
			else if (r>255) r = 255;
			if (g<0) g = 0;
			else if (g>255) g = 255;
			if (b<0) b = 0;
			else if (b>255) b = 255;
			*buffer++ = r<<16 | g<<8 | b;
		}
	}
}

