#include <stdlib.h>
#include <string.h>
#include "mini.h"


Mini::Mini(int w, int h) {
	width = w;
	height = h;
	miniBuffer = NULL;
}

Mini::~Mini(void) {
	free(miniBuffer);
}

void Mini::init(void) {
	miniBuffer = (unsigned int*) malloc(sizeof(int)*(width/4)*(height/4));
}

void Mini::draw(unsigned int *buffer) {
	unsigned int *outptr = miniBuffer;
	unsigned int *inptr;
	for (int y = 0; y < height; y += 4) {
		inptr = buffer + y*width;
		for (int x = 0; x < width; x += 4) {
			*outptr++ = *inptr;
			inptr += 4;
		}
	}

	inptr = miniBuffer;
	outptr = buffer;
	for (int i = 0; i < height/4; i++) {
		memcpy(outptr,inptr,sizeof(int)*width/4);
		inptr += width/4;
		outptr += width;
	}
}


